import {
    getSuppliesTemplate,
    listSuppliesTemplate,
    listMyluckyexcel,
} from "@/api/ruoyi-myLuckyexcel/myluckyexcel";
import {
    conversionSave,
    surface,
    getRecentFormulas,
    importLxWagesExcel,
    lxSummary
} from "@/api/conversion/index";
// import luckysheet from 'luckysheet'
import LuckyExcel from "luckyexcel";
import { exportExcel } from "../../public/exportExcel";
import { machGzdata } from "@/Wages/conversTsk.js";
import { machLxGzdata } from "@/Wages/conversLxk.js";
import { transformJson, tzcCreateData, newGettransformJson, collect } from "@/utils/tzc"
var fileName = "新建XLSX工作表"; //定义表名
var modify = false;
var that;
export default {
    name: "Mymodule",
    data() {
        return {
            wageMonth: "",
            //详细信息
            phone: "",
            //moban
            //未导入成本材料表模板所有数据
            jsondata: "",
            //编码数据
            showMask: false,
            uuid: "",
            selectedOption: "",
            luckysheetData: "",
            luckysheetDatas: "",
            depss: [],
            fileList: [],
            VoucherForm: "",
            dialogTableVisible: false,
            all: "",
            jsonhead: [],
            sum: [],
            // 查询参数
            queryParams: {
                status: 0,
            },
            mineId: '',//矿ID
        };
    },
    created() {
        that = this;
        //刷新页面时进行的操作
        this.getList();
    },

    mounted() {
        this.init();
        fileName = "新建XLSX工作表";
    },
    methods: {
        //查询材料编码
        //手机号
        open() {
            this.$prompt("请输入用友系统的用户名", "提示", {
                confirmButtonText: "确定",
                cancelButtonText: "取消",
                inputPattern: /^(?:\+?86)?1[3-9]\d{9}$/,
                inputErrorMessage: "手机号格式不正确",
            })
                .then(({ value }) => {
                    this.$message({
                        type: "success",
                        message: "你的用户名是: " + value,
                    });
                    this.phone = value;
                    this.zhuan();
                })
                .catch(() => {
                    this.$message({
                        type: "info",
                        message: "取消输入",
                    });
                    this.showMask = false;
                });
        },
        /** 页面刷新时展示的数据*/
        getList() {
            listSuppliesTemplate(this.queryParams).then((response) => {
                response.rows.forEach((row) => {
                    if (row.templateName.includes("六矿")) {
                        row.disabled = true;
                    }
                });
                this.depss = response.rows;
            });

            getSuppliesTemplate(1248).then((response) => {
                const sysSupplies = response.rows;
                this.luckysheetDatas = JSON.parse(
                    sysSupplies[0].templateContent
                );
            });
        },

        open4() {
            this.$message.error("请仔细检查所导入表");
        },
        init() {
            let options = {
                container: "luckysheet", //luckysheet为容器id
                title: "",
                lang: "zh",
                showinfobar: false,
                data: [
                    {
                        name: "sheet1", //工作表名称
                        color: "", //工作表颜色
                        index: 0, //工作表索引
                        status: 1, //激活状态
                        order: 0, //工作表的下标
                        hide: 0, //是否隐藏
                        row: 50, //行数
                        column: 20, //列数
                        defaultRowHeight: 19, //自定义行高
                        defaultColWidth: 73, //自定义列宽
                        celldata: [], //初始化使用的单元格数据
                        config: {
                            merge: {}, //合并单元格
                            rowlen: {}, //表格行高
                            columnlen: {}, //表格列宽
                            rowhidden: {}, //隐藏行
                            colhidden: {}, //隐藏列
                            borderInfo: {}, //边框
                            authority: {}, //工作表保护
                        },
                    },
                ],
            };
            luckysheet.create(options);
        },

        handleSuccess(response, file, fileList) {
        },
        //工资数据后台导入成功后，数据展示到前台
        loadTableData(evt) {
            this.sum.push(evt);
            if (modify) {
                this.$confirm(
                    "再次导入将会清空表内数据,是否继续操作？",
                    "注意!!!",
                    {
                        confirmButtonText: "确定",
                        cancelButtonText: "取消",
                        type: "warning",
                    }
                )
                    .then(async () => {
                        // 确认继续后刷新页面返回模板
                        getSuppliesTemplate(this.selectedOption)
                            .then((response) => {
                                const sysSupplies = response.rows;
                                this.luckysheetData =
                                    sysSupplies[0].templateContent;
                                let json_data = JSON.parse(
                                    sysSupplies[0].templateContent
                                );
                                luckysheet.destroy();
                                luckysheet.create({
                                    container: "luckysheet", // Luckysheet 的容器元素 ID
                                    title: fileName, // Excel 文件名
                                    data: json_data, // Excel 数据
                                    allowEdit: false, //作用：是否允许前台编辑
                                    showinfobar: false, //是否显示顶部名称栏
                                    lang: "zh",
                                });
                                modify = false;
                                this.open(this.sum);
                            })
                            .then(async () => { })
                            .catch(() => { });
                    })
                    .catch(() => {
                        // 用户点击了取消按钮
                        this.$message({
                            type: "info",
                            message: "操作已取消",
                        });
                    });
            } else {
                this.open(evt);
                this.showMask = true;
                LuckyExcel(evt, (exportJson) => {
                    //获取导入表格所有数据exportJson
                    this.open(exportJson)
                        .then(async () => { })
                        .catch((error) => {
                            this.$message({
                                message: error.message,
                                type: "error",
                            });
                        })
                        .finally(() => {
                            // 导入完成后关闭遮罩层
                            this.showMask = false;
                        });
                });
            }
        },

        async handleFileChange(evt) {
            if (this.value.includes("凭证")) {
                this.loadTableData(evt);
            } else if (this.value.includes("林西")) {
                //组装后台接口数据
                var param = new FormData();
                param.append("file", evt);
                param.append("date", this.wageMonth);
                param.append("mineId", this.mineId);
                param.append("identification", "0");
                //林西矿工资基础数据导入
                importLxWagesExcel(param).then((res) => {
                    //导入成功
                    if (res.code == 200) {
                        this.loadTableData(evt);
                    } else {
                        this.$message.error("后台数据导入失败!");
                    }
                });
            } else {
                //组装后台接口数据
                var param = new FormData();
                param.append("file", evt);
                param.append("date", this.wageMonth);

                listMyluckyexcel(param).then((res) => {
                    //导入成功
                    if (res.code == 200) {
                        this.loadTableData(evt);
                    } else {
                        this.$message.error("后台数据导入失败!");
                    }
                });
            }
            //前台加载数据
        },
        handleOptionChange(value, mine_id) {
            that.mineId = mine_id.id
            let lod = this.$loading({
                lock: true,
                text: "加载中",
                background: "rgba(0, 0, 0, 0.7)",
            });
            //根据选中的下拉选项值获取相应的信息
            getSuppliesTemplate(this.selectedOption)
                .then((response) => {
                    lod.close();
                    modify = false;
                    const sysSupplies = response.rows;
                    this.luckysheetData = sysSupplies[0].templateContent;
                    var json_data = JSON.parse(sysSupplies[0].templateContent);
                    this.jsondata = json_data;
                    let suffixArr = sysSupplies[0].templateName.split(".");
                    fileName = suffixArr[0];
                    //luckysheet.destroy()
                    luckysheet.create({
                        container: "luckysheet", // Luckysheet 的容器元素 ID
                        title: fileName, // Excel 文件名
                        data: json_data, // Excel 数据
                        showinfobar: false,
                        allowEdit: false, //是否显示顶部名称栏
                        lang: "zh",
                        index: "0", //工作表索引
                        status: "1", //激活状态
                    });
                    this.value = fileName;


                    if (!fileName.includes("凭证")) {
                        var excel_r = 0;//读取行
                        var excel_c = 0;//读取起始列

                        if (fileName.includes("唐山")) {
                            excel_r = 2;
                        } else if (fileName.includes("林西")) {
                            excel_r = 3;
                        }
                        let head = this.jsondata[0].celldata.filter(
                            (item) => item.r && item.r == excel_r && item.c > excel_c
                        );
                        this.jsonhead = [];
                        head.forEach((item) => {
                            let funct = {
                                label: item.v.v + "=",
                                c: item.c,
                                value: "",
                            };
                            this.jsonhead.push(funct);
                        });

                        //获取最新的公式
                        getRecentFormulas(that.mineId).then((response) => {
                            if (response.code == 200) {
                                var data = response.data;

                                if (data) {
                                    var json = JSON.parse(data);

                                    json.forEach((item) => {
                                        if (item.value) {
                                            this.jsonhead.forEach(
                                                (head) => {
                                                    if (
                                                        item.label ==
                                                        head.label
                                                    ) {
                                                        head.value =
                                                            item.value;
                                                    }
                                                }
                                            );
                                        }
                                    });
                                }
                            }
                        });
                    }
                })
                .catch(() => {
                    lod.close();
                    // 处理错误逻辑，这里是一个空的错误处理函数
                    this.$message.error("查询失败,发生未知错误!");
                });
        },
        initData() {
            try {
                // 将 this.jsonhead 转换为 JSON 字符串
                const postData = this.jsonhead.filter(
                    (item) => item.value.trim() != ""
                );

                // 使用 localStorage 存储
                //localStorage.setItem('myData', jsonString);
                this.dialogTableVisible = false;
                const CompositeTable = this.jsondata;

                var putJson = {
                    date: this.wageMonth,
                    data: postData,
                };

                //林西矿
                if (this.selectedOption == 1280) {
                    //林西矿工资汇总
                    lxSummary(putJson).then((response) => {
                        if (response.code == 200) {
                            var data = response.data;
                            let myCompositeTable = machLxGzdata(
                                data,
                                CompositeTable
                            );
                            this.setLuckysheetData(CompositeTable, myCompositeTable);

                        } else {
                        }
                    });
                } else {

                    //唐山工资汇总
                    surface(putJson).then((response) => {
                        if (response.code == 200) {
                            var data = response.data;
                            let myCompositeTable = machGzdata(
                                data,
                                CompositeTable
                            );

                            this.setLuckysheetData(CompositeTable, myCompositeTable);


                        } else {
                        }
                    });
                }
            } catch {
                this.open4();
                modify = true;
                this.showMask = false;
            }
        },
        //工资数据后台汇总完后，回显到前台
        setLuckysheetData(CompositeTable, myCompositeTable) {
            CompositeTable[0].data = luckysheet.transToData(
                myCompositeTable[0].celldata
            );

            CompositeTable[0].calcChain = [];
            let as = CompositeTable[0].celldata.filter(
                (item) => item.v.f
            );
            as.forEach((item) => {
                let sum = {
                    index: CompositeTable[0].index,
                    r: item.r,
                    c: item.c,
                };
                CompositeTable[0].calcChain.push(sum);
            });

            CompositeTable[0].celldata[0].status = 1;
            luckysheet.create({
                forceCalculation: true,
                container: "luckysheet",
                title: fileName,
                data: CompositeTable,
                showinfobar: false,
                lang: "zh",
            });
            var jsonString = JSON.stringify(this.jsonhead);
            let obj = {
                yearMonth: this.wageMonth,
                jsonData: JSON.stringify(CompositeTable),
                value: jsonString,
                mineId: that.mineId,
         
            };

            modify = true;
            that.showMask = false;
            conversionSave(obj).then((response) => {
            });
        },
        //转换方法
        zhuan() {
            const promises = this.sum.map((item) => {
                return new Promise((resolve, reject) => {
                    LuckyExcel.transformExcelToLucky(item, (lucksheetfile) => {
                        resolve(lucksheetfile);
                    });
                });
            });
            Promise.all(promises).then((results) => {
                let sum = [];
                //计算全部单位工资总和
                results.forEach((item) => {
                    sum.push(...item.sheets);
                });
                if (this.value.includes("凭证")) {
                    this.VoucherForms(sum);
                } else {
                    this.all = sum;
                    this.dialogTableVisible = true;
                }
            });
        },
        //公式窗口关闭回调
        handleClose() {
            that.dialogTableVisible = false;
            that.showMask = false;
        },
        async VoucherForms(sum) {
            try {
                let objks = await newGettransformJson(sum, that.mineId)
                let createData = tzcCreateData(
                    this.luckysheetDatas,
                    transformJson(objks.data),
                    luckysheet,
                    this.phone,
                    this.wageMonth
                );
                createData = collect(createData)
                luckysheet.create({
                    container: "luckysheet", // Luckysheet 的容器元素 ID
                    title: fileName, // Excel 文件名
                    allowEdit: false, //作用：是否允许前台编辑
                    data: createData, // Excel 数据
                    showinfobar: false, //是否显示顶部名称栏
                    lang: "zh",
                });
                modify = true;
                this.showMask = false;

            } catch {
                modify = true;
                this.showMask = false;
                this.open4();
            }
        },
        handleExport: debounce(function () {
            // handleExport

            exportExcel(luckysheet.getAllSheets(), fileName);
        }, 500),
    },
};

// debounce函数定义
function debounce(func, delay) {
    let timer;
    return function () {
        const context = this;
        const args = arguments;
        clearTimeout(timer);
        timer = setTimeout(function () {
            func.apply(context, args);
        }, delay);
    };
}
