import { setXColumn, tzcCreateData, transformJson } from '@/utils/tzc'
import Decimal from 'decimal.js';
import { getyy, getSuppliesTemplate } from '@/api/ruoyi-myLuckyexcel/myluckyexcel'
import source from 'echarts/src/data/Source'
export function ex(luckysheetdata, roleObj) {
    let list = []
    for (let index = 1; index < luckysheetdata.length; index++) {
        let funct = {}
        luckysheetdata[index].forEach((item, e) => {
            if (item && item.v && (e == 5 || e == 9 || e == 10)) {
                let name = luckysheetdata[0][e].v;
                funct[name] = item.v;
            }
        });
        list.push(funct);
    }
    let result = list.reduce((acc, curr) => {
        let existing = acc.find(item => item.费用来源 === curr.费用来源 && item.一级材料类别 === curr.一级材料类别);
        if (existing) {
            existing.总额 = new Decimal(existing.总额).plus(curr.总额).toString();
        } else {
            acc.push({ ...curr });
        }
        return acc;
    }, []);
    let newdata = luckysheet.transToData(roleObj[0].celldata);
    let headers = setXColumn(newdata, 3)
    let obj = {

    }
    result.forEach(item => {
        if (obj[item['费用来源']]) {
            obj[item['费用来源']].push(item)
        } else {
            obj[item['费用来源']] = [item]
        }
    })
    Object.entries(obj).forEach(([source, value], rowI) => {
        let row = newdata[rowI + 4]
        // item.费用来源 === curr.费用来源 && item.一级材料类别
        row[0] = { ct: { fa: '@', t: 's' }, fc: "#000000", ff: "宋体", v: source }
        value.forEach(item => {
            let ci = headers[item['一级材料类别']]
            if (ci > -1) {
                row[ci] = { ct: { fa: '@', t: 's' }, fc: "#000000", ff: "宋体", v: item['总额'] }
            }
        })
    })
    roleObj[0].celldata = luckysheet.transToCellData(newdata)
    roleObj[0].calcChain = [];
    let as = roleObj[0].celldata.filter(
        (item) => item.v.f
    );
    as.forEach((item) => {
        let sum = {
            index: roleObj[0].index,
            r: item.r,
            c: item.c,
        };
        roleObj[0].calcChain.push(sum);
    });

    luckysheet.destroy();
    luckysheet.create({
        forceCalculation: true,
        container: "luckysheet", // Luckysheet 的容器元素 ID
        lang: 'zh',
        title: '汇总模板',
        data: roleObj
    });
    return true
}
export async function Certificate_method(celldatas, mining_id, date, phone) {
    let selectedOption = [
        {
            value: '待分析材料分配',
            id: '010102',
            noIn: '基本生产原煤-火工品'
        },
        {
            value: '材料分配',
            id: '011701',
            noIn: '',
        },
        {
            value: '材料分配',
            id: '011704',
            noIn: '基本生产原煤-木材'
        },
        {
            value: '本月材料分析',
            id: '011702',
            noIn: ''

        },
        {
            value: '转本月材料分配',
            id: '010101',
            noIn: '基本生产原煤-火工品'
        },
        {
            value: '转本月材料分配',
            id: '011204',
            noIn: ''
        },
        {
            value: '原材料分配',
            id: '010105',
            noIn: '基本生产原煤-火工品'
        },
        {
            value: '宏丰',
            id: '011502',
            noIn: ''
        },
        {
            value: '云飞',
            id: '011504',
            noIn: ''
        },
        {
            value: '中润',
            id: '011706',
            noIn: ''
        },

    ]
    let result = selectedOption.find(item => item.id == mining_id);
    let merge = []
    let disposition = {
        endcolumn: '12',//结束列
        startcolumn: '1',//开始列
        endrow: '28',//结束行
        startrow: '4',//开始行
        headcolumn: '0',//表头列
        headrow: '3',//表头行
    }
    celldatas.forEach(item => {
        if (item.v && item.v.v) {
            let funct = {
                r: item.r,
                c: item.c,
                v: item.v.v
            }
            merge.push(funct)
        }
    }
    )
    let head = merge.filter(item => item.r == disposition.headrow && item.c <= disposition.endcolumn && item.c > disposition.headcolumn);
    let classary = merge.filter(item => item.c == disposition.headcolumn && item.r > disposition.headrow && item.r < disposition.endrow);
    // 筛选数据
    let data = merge.filter(item =>
        item.r >= disposition.startrow && item.r <= disposition.endrow &&
        item.c >= disposition.startcolumn && item.c <= disposition.endcolumn
    )
    data.forEach(item => {
        classary.forEach(obj => {
            if (item.r == obj.r) {
                item.r = obj.v
            }
        })
        head.forEach(obj => {
            if (item.c == obj.c) {
                item.c = obj.v
            }
        })
    })

    const borrow = data.map(item => {
        const newR = item.r.replace(/-/g, '');
        const newKey = `${newR}-${item.c}`;
        return { "name": newKey, "money": item.v, 'mining': result.id, 'is_debit': 0, 'classary': result.value };
    });
    let funct = {
        name: '其他应付款_待分析',
        money: new Decimal(0),
        is_debit: 1,
        classary: result.value,
        mining: result.id
    }
    let loan = []
    borrow.forEach(item => {
        if (item.name !== result.noIn) {
            funct.money = funct.money.plus(new Decimal(item.money));
        } else {
            const newItem = { ...item };
            newItem.is_debit = 1
        }
    })
    loan.push(funct)
    let res = await getyy(JSON.stringify({ borrow, loan }))
    let template = await getSuppliesTemplate(1248)
    console.log(template)
    let createData = tzcCreateData(
        JSON.parse(template.rows[0].templateContent),
        transformJson(res.data),
        luckysheet,
        date,
        phone
    );
    console.log(createData)
    luckysheet.create({
        container: "luckysheet", // Luckysheet 的容器元素 ID
        title: '凭证', // Excel 文件名
        allowEdit: false, //作用：是否允许前台编辑
        data: createData, // Excel 数据
        showinfobar: false, //是否显示顶部名称栏
        lang: "zh",
    });

}