package com.ruoyi.system.controller;


import com.google.gson.Gson;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.system.model.power.dao.LxPower;
import com.ruoyi.system.model.power.dao.LxPowerDAO;
import com.ruoyi.system.model.power.dao.PowerAllDAO;
import com.ruoyi.system.model.power.dao.PowerDAO;
import com.ruoyi.system.model.power.vo.PowerVo;
import com.ruoyi.system.service.PowerWagesService;
import lombok.RequiredArgsConstructor;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;

/**
 * @author haiwe
 * @date 2024/6/26
 */
@RestController
@RequestMapping("/power")
@RequiredArgsConstructor
public class PowerWagesController {
    private final PowerWagesService powerWagesService;
    /**
     * 唐山矿电力表格导入
     *
     * @return
     */
    @PostMapping("/all")
    public AjaxResult save(@RequestParam("file") MultipartFile file,
                           @RequestPart String powerDAO,
                           @RequestPart String powerAllDAO
    ) {
        //字符串转json格式
        Gson gson = new Gson();
        PowerDAO powerDAO1 = gson.fromJson(powerDAO, PowerDAO.class);
        PowerAllDAO powerAllDAO1 = gson.fromJson(powerAllDAO, PowerAllDAO.class);
        //1、处理表格
        String date = powerDAO1.getImportTime();
        String mineId = powerDAO1.getMineId();
        Boolean cAnalyzed = powerWagesService.readCExcel(file, date, mineId);
        if (!cAnalyzed) {
            return AjaxResult.error("解析失败");
        }
        Boolean dAnalyzed = powerWagesService.readDExcel(file, date, mineId);
        if (!dAnalyzed) {
            return AjaxResult.error("解析失败");
        }
        //2、处理特殊表的表头
        Boolean added = powerWagesService.add(powerDAO1);
        if (!added) {
            return AjaxResult.error("对照处理失败");
        }
        //3、处理特殊表的数据
        Boolean pAdd = powerWagesService.pAdd(powerAllDAO1);
        if (!pAdd) {
            return AjaxResult.error("数据处理失败");
        }
        //返回数据
        List<PowerVo> data = powerWagesService.selectByMineIdAndDate(mineId, date);
        return AjaxResult.success(data);
    }


    @PostMapping("lxPower")
    public AjaxResult lxPower(@RequestBody LxPowerDAO lxPowerDAO) {
        List<LxPower> lxPowers = lxPowerDAO.getLxPowers();
        Boolean inserted =  powerWagesService.insert(lxPowers);
        if (!inserted) {
            return AjaxResult.error("存储数据失败!");
        }
        return AjaxResult.success();
    }
}
