package com.ruoyi.system.controller;

import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.system.model.wages.dto.WagesFormulaListDto;
import com.ruoyi.system.model.wages.vo.WagesFormulaVo;
import com.ruoyi.system.service.WagesCalculateConversionService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.RequiredArgsConstructor;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * 2024/5/21
 */

@RestController
@Api(tags = "工资转化模版")
@RequestMapping("/wages/calculate")
@RequiredArgsConstructor
public class WagesCalculateConversionController {

    private final WagesCalculateConversionService wagesCalculateConversionService;
    /**
     * 唐山矿转换表
     */
    @PostMapping(value = "/surface")
    @ApiOperation(value = "唐山矿转换表")
    public AjaxResult conversionSurface( @RequestBody WagesFormulaListDto wagesFormulaListDto) throws NoSuchFieldException, IllegalAccessException {
        List<WagesFormulaVo> data = wagesCalculateConversionService.conversionSurface(wagesFormulaListDto);
        return new AjaxResult(200, "成功", data);
    }
}
