package com.ruoyi.system.listener;

import com.alibaba.excel.context.AnalysisContext;
import com.alibaba.excel.event.AnalysisEventListener;
import com.ruoyi.system.model.salary.LjtSalaryModel;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.ArrayList;
import java.util.List;

public class LjtExcelListener<T> extends AnalysisEventListener<T> {

    private final static Logger logger = LoggerFactory.getLogger(LjtExcelListener.class);

    private final List<LjtSalaryModel> ljtSalaryModelList = new ArrayList<>();

    private int endRow;

    @Override
    public void invoke(T t, AnalysisContext analysisContext) {
        LjtSalaryModel ljtSalaryModel = (LjtSalaryModel) t;
        if (StringUtils.equals("合计", ljtSalaryModel.getOrg())) {
            endRow = analysisContext.getCurrentRowNum();
        }
        int count = analysisContext.getCurrentRowNum();
        if (endRow == 0 || (endRow - 1 >= count)) {
            ljtSalaryModelList.add(ljtSalaryModel);
        }
    }

    @Override
    public void doAfterAllAnalysed(AnalysisContext analysisContext) {
        logger.info("解析完成!");
    }

    public List<LjtSalaryModel> getLjtSalaryModelList() {
        return ljtSalaryModelList;
    }
}
