package com.ruoyi.system.listener;


import com.alibaba.excel.context.AnalysisContext;
import com.alibaba.excel.event.AnalysisEventListener;
import com.ruoyi.system.model.salary.LxSalaryModel;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.ArrayList;
import java.util.List;

public class LxExcelListener<T> extends AnalysisEventListener<T> {

    private final static Logger logger = LoggerFactory.getLogger(LxExcelListener.class);

    List<LxSalaryModel> lxSalaryModelList = new ArrayList<>();

    private int endRow;

    @Override
    public void invoke(T t, AnalysisContext analysisContext) {
        LxSalaryModel lxSalaryModel = (LxSalaryModel) t;
        if (StringUtils.equals("病亡", lxSalaryModel.getOrg())) {
            endRow = analysisContext.getCurrentRowNum();
        }
        int count = analysisContext.getCurrentRowNum();
        if (endRow == 0 || (endRow + 1 >= count)) {
            lxSalaryModelList.add(lxSalaryModel);
        }
    }

    @Override
    public void doAfterAllAnalysed(AnalysisContext analysisContext) {
        logger.info("解析完成!");
    }

    public List<LxSalaryModel> getLxSalaryModelList() {
        return lxSalaryModelList;
    }


}
