package com.ruoyi.system.listener;

import com.alibaba.excel.context.AnalysisContext;
import com.alibaba.excel.event.AnalysisEventListener;
import com.ruoyi.system.model.salary.LxInsuranceModel;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.ArrayList;
import java.util.List;

public class LxInsuranceListener<T> extends AnalysisEventListener<T> {

    private final static Logger logger = LoggerFactory.getLogger(LxInsuranceListener.class);

    List<LxInsuranceModel> lxInsuranceModels = new ArrayList<>();

    private int endRow;

    @Override
    public void invoke(T t, AnalysisContext analysisContext) {
        LxInsuranceModel lxInsuranceModel = (LxInsuranceModel) t;
        if (StringUtils.equals("小计", lxInsuranceModel.getOrg())) {
            endRow = analysisContext.getCurrentRowNum();
        }
        int count = analysisContext.getCurrentRowNum();
        if (endRow == 0 || (endRow == count)) {
            lxInsuranceModels.add(lxInsuranceModel);
        }
    }

    @Override
    public void doAfterAllAnalysed(AnalysisContext analysisContext) {
        logger.info("解析完成!");
    }

    public List<LxInsuranceModel> getLxInsuranceModels() {
        return lxInsuranceModels;
    }
}
