package com.ruoyi.system.service.impl;

import com.alibaba.excel.EasyExcel;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.system.listener.DhtExcelListener;
import com.ruoyi.system.mapper.SalaryMapper;
import com.ruoyi.system.model.salary.DhtSalaryModel;
import com.ruoyi.system.model.salary.SalaryExcelModel;
import com.ruoyi.system.service.DhtSalaryService;
import com.ruoyi.system.support.DhtSupport;
import lombok.SneakyThrows;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import java.io.InputStream;
import java.util.List;

@Service
public class DhtSalaryServiceImpl implements DhtSalaryService {

    private final SalaryMapper salaryMapper;

    public DhtSalaryServiceImpl(SalaryMapper salaryMapper) {
        this.salaryMapper = salaryMapper;
    }

    @Override
    @SneakyThrows
    public AjaxResult dhtSave(MultipartFile multipartFile, String salaryDate) {
        InputStream inputStream = multipartFile.getInputStream();
        DhtExcelListener<DhtSalaryModel> dhtExcelListener = new DhtExcelListener<>();
        EasyExcel.read(inputStream, DhtSalaryModel.class, dhtExcelListener).sheet(1).headRowNumber(1).doRead();
        List<DhtSalaryModel> dhtSalaryModelList = dhtExcelListener.getDhtSalaryModelList();
        List<SalaryExcelModel>salaryExcelModelList= DhtSupport.getSalaryExcelModelList(dhtSalaryModelList,salaryDate,salaryMapper);
        salaryMapper.save(salaryExcelModelList);
        return AjaxResult.success();
    }
}
