package com.ruoyi.system.service.impl;

import com.alibaba.excel.EasyExcelFactory;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.system.listener.ExcelListener;
import com.ruoyi.system.mapper.ImportExpenseSourceMapper;
import com.ruoyi.system.model.salary.SalaryExpenseSourceModel;
import com.ruoyi.system.service.ImportExpenseSourceService;
import lombok.SneakyThrows;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;

@Service
public class ImportExpenseSourceServiceImpl implements ImportExpenseSourceService {

    private final ImportExpenseSourceMapper importExpenseSourceMapper;

    public ImportExpenseSourceServiceImpl(ImportExpenseSourceMapper importExpenseSourceMapper) {
        this.importExpenseSourceMapper = importExpenseSourceMapper;
    }

    @Override
    @SneakyThrows
    public AjaxResult expenseSource(MultipartFile multipartFile) {
        List<SalaryExpenseSourceModel> list= EasyExcelFactory.read(multipartFile.getInputStream(), SalaryExpenseSourceModel.class,new ExcelListener<>()).sheet("Sheet1").headRowNumber(1).doReadSync();
        list.forEach(v->v.setOrgCode("011702"));
        importExpenseSourceMapper.save(list);
        return AjaxResult.success();
    }
}
