package com.ruoyi.system.service.impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.system.mapper.RuleMapper;
import com.ruoyi.system.model.rule.RuleRequestModel;
import com.ruoyi.system.service.RuleService;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Service
public class RuleServiceImpl implements RuleService {
    private final RuleMapper ruleMapper;

    public RuleServiceImpl(RuleMapper ruleMapper) {
        this.ruleMapper = ruleMapper;
    }


    @Override
    public AjaxResult save(RuleRequestModel ruleRequestModel) {
        ruleMapper.save(ruleRequestModel, JSON.toJSONString(ruleRequestModel.getRules()));
        return AjaxResult.success();
    }

    @Override
    public AjaxResult query(String ruleRequestModel) {
        List<RuleRequestModel> ruleRequest = ruleMapper.query(ruleRequestModel);
        List<String> stringList = ruleMapper.queryOfId(ruleRequestModel);
        for (int i = 0; i < ruleRequest.size(); i++) {
            RuleRequestModel ruleRequestModel1 = ruleRequest.get(i);
            String s = stringList.get(i);
            ObjectMapper mapper = new ObjectMapper();
            try {
                JSONArray jsonArray = mapper.readValue(s, JSONArray.class);
                ruleRequestModel1.setRules(jsonArray);
            } catch (JsonProcessingException e) {
                e.printStackTrace();
            }
        }
        return new AjaxResult(200, "成功", ruleRequest);
    }

    @Override
    public AjaxResult updateToId(RuleRequestModel ruleRequestModel) {
        ruleMapper.updateToId(ruleRequestModel, JSON.toJSONString(ruleRequestModel.getRules()));
        return AjaxResult.success();
    }

    @Override
    @Transactional
    public AjaxResult deleteById(RuleRequestModel ruleRequestModel) {
        String id=ruleRequestModel.getId();
        ruleMapper.deleteById(id);
        ruleMapper.deleteByTemplateId(id);
        return AjaxResult.success();
    }
}
