package com.ruoyi.system.service.impl;

import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.system.constant.CoalConstant;
import com.ruoyi.system.model.SalaryPowerUnifyExposeRequestModel;
import com.ruoyi.system.service.PowerDisplayService;
import com.ruoyi.system.service.SalaryCurrentRuleService;
import com.ruoyi.system.service.SalaryPowerUnifyExposeService;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;

@Service
public class SalaryPowerUnifyExposeServiceImpl implements SalaryPowerUnifyExposeService {

    private final PowerDisplayService powerDisplayService;

    private final SalaryCurrentRuleService salaryCurrentRuleService;

    public SalaryPowerUnifyExposeServiceImpl(PowerDisplayService powerDisplayService, SalaryCurrentRuleService salaryCurrentRuleService) {
        this.powerDisplayService = powerDisplayService;
        this.salaryCurrentRuleService = salaryCurrentRuleService;
    }


    @Override
    public AjaxResult unify(SalaryPowerUnifyExposeRequestModel salaryPowerUnifyExposeRequestModel) {
        //工资
        if (StringUtils.equals(CoalConstant.ZERO, salaryPowerUnifyExposeRequestModel.getType())) {
            salaryCurrentRuleService.getCurrentRuleSalary(salaryPowerUnifyExposeRequestModel.getNewRuleSalaryModelList());
        }
        //电力
        if (StringUtils.equals(CoalConstant.ONE, salaryPowerUnifyExposeRequestModel.getType())) {
            powerDisplayService.peek(salaryPowerUnifyExposeRequestModel.getNewRuleSalaryModelList());
        }
        return AjaxResult.success();
    }
}
