package com.ruoyi.system.support;

import com.ruoyi.system.constant.CoalConstant;
import com.ruoyi.system.model.salary.LxInsuranceModel;
import com.ruoyi.system.model.salary.LxSalaryModel;
import com.ruoyi.system.model.salary.SalaryExcelModel;
import org.apache.commons.lang3.StringUtils;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class LxSupport {

    /**
     * 林西矿费用渠道
     */
    public final static Map<String, String> CHANNEL_MAP = new HashMap<>();

    static {
        CHANNEL_MAP.put("物管科", "原煤");
        CHANNEL_MAP.put("生活后勤服务中心", "原煤");
        CHANNEL_MAP.put("环保迁建科", "原煤");
        CHANNEL_MAP.put("机电制造分公司", "原煤");
        CHANNEL_MAP.put("洗煤厂", "基本生产洗煤");
        CHANNEL_MAP.put("外借公司", "其他业务成本");
        CHANNEL_MAP.put("机关", "管理费用");
        CHANNEL_MAP.put("矿领导", "管理费用");
        CHANNEL_MAP.put("培训中心", "管理费用");
        CHANNEL_MAP.put("退休", "管理费用");
        CHANNEL_MAP.put("煤管科", "销售费用");
        CHANNEL_MAP.put("研发支出", "其他");
        CHANNEL_MAP.put("离岗休息", "辞退福利");
        CHANNEL_MAP.put("长病", "其他长期职工福利");
        CHANNEL_MAP.put("长伤", "其他长期职工福利");
        CHANNEL_MAP.put("综采一区", "基本生产原煤");
        CHANNEL_MAP.put("综采二区", "基本生产原煤");
        CHANNEL_MAP.put("掘进一区", "基本生产原煤");
        CHANNEL_MAP.put("掘进二区", "基本生产原煤");
        CHANNEL_MAP.put("掘进三区", "基本生产原煤");
        CHANNEL_MAP.put("开拓区", "基本生产原煤");
        CHANNEL_MAP.put("准备区", "基本生产原煤");
        CHANNEL_MAP.put("皮带区", "基本生产原煤");
        CHANNEL_MAP.put("通风区", "基本生产原煤");
        CHANNEL_MAP.put("救护队", "基本生产原煤");
        CHANNEL_MAP.put("井运区", "基本生产原煤");
        CHANNEL_MAP.put("机电科", "基本生产原煤");
        CHANNEL_MAP.put("机采科", "基本生产原煤");
        CHANNEL_MAP.put("设备通讯科", "基本生产原煤");
        CHANNEL_MAP.put("地测科", "基本生产原煤");
        CHANNEL_MAP.put("保卫科", "基本生产原煤");
        CHANNEL_MAP.put("水处理厂", "基本生产原煤");
    }

    public static List<SalaryExcelModel> getSalaryExcelModelList(List<LxSalaryModel> lxSalaryModelList) {
        List<SalaryExcelModel> salaryExcelModelList = new ArrayList<>();
        for (LxSalaryModel lxSalaryModel : lxSalaryModelList) {
            SalaryExcelModel salaryExcelModel = new SalaryExcelModel();
            salaryExcelModel.setOrg(lxSalaryModel.getOrg());
            salaryExcelModel.setPersonCount(lxSalaryModel.getPersonCount());
            salaryExcelModel.setSumSalary(lxSalaryModel.getSumSalary());
            salaryExcelModel.setLunch(lxSalaryModel.getLunch());
            salaryExcelModel.setOneChild(lxSalaryModel.getOneChild());
            salaryExcelModel.setHonorMoney(lxSalaryModel.getHonorMoney());
            salaryExcelModel.setHeatPreventSubsidy(lxSalaryModel.getHeatPreventSubsidy());
            salaryExcelModelList.add(salaryExcelModel);
        }
        return salaryExcelModelList;
    }

    public static List<SalaryExcelModel> getInsuranceList(List<LxInsuranceModel> lxInsuranceModelList) {
        List<SalaryExcelModel> salaryExcelModelList = new ArrayList<>();
        for (LxInsuranceModel insuranceModel : lxInsuranceModelList) {
            SalaryExcelModel salaryExcelModel = new SalaryExcelModel();
            salaryExcelModel.setOrg(insuranceModel.getOrg());
            salaryExcelModel.setPersonCount(insuranceModel.getPersonCount());
            salaryExcelModel.setOldInsurance(insuranceModel.getOldInsurance());
            salaryExcelModel.setMedicalInsurance(insuranceModel.getMedicalInsurance());
            salaryExcelModel.setSupplyMedicalInsurance(insuranceModel.getSupplyMedicalInsurance());
            salaryExcelModel.setUnemploymentInsurance(insuranceModel.getUnemploymentInsurance());
            salaryExcelModel.setInjuryInsurance(insuranceModel.getInjuryInsurance());
            salaryExcelModelList.add(salaryExcelModel);
        }
        return salaryExcelModelList;
    }


    public static List<SalaryExcelModel> getSalaryExcelModels(List<SalaryExcelModel> salaryExcelModelList, List<SalaryExcelModel> list, String salaryDate) {
        List<SalaryExcelModel> salaryExcelModels = new ArrayList<>();
        for (SalaryExcelModel salaryExcelModel : salaryExcelModelList) {
            SalaryExcelModel model = new SalaryExcelModel();
            for (SalaryExcelModel excelModel : list) {
                if (StringUtils.equals(salaryExcelModel.getOrg(), excelModel.getOrg())) {
                    model.setOrg(excelModel.getOrg());
                    model.setSalaryDate(salaryDate);
                    model.setPersonCount(excelModel.getPersonCount());
                    model.setSumSalary(excelModel.getSumSalary());
                    model.setLunch(excelModel.getLunch());
                    model.setOneChild(excelModel.getOneChild());
                    model.setHonorMoney(excelModel.getHonorMoney());
                    model.setHeatPreventSubsidy(excelModel.getHeatPreventSubsidy());
                    model.setOldInsurance(salaryExcelModel.getOldInsurance());
                    model.setMedicalInsurance(salaryExcelModel.getMedicalInsurance());
                    model.setSupplyMedicalInsurance(salaryExcelModel.getSupplyMedicalInsurance());
                    model.setUnemploymentInsurance(salaryExcelModel.getUnemploymentInsurance());
                    model.setInjuryInsurance(salaryExcelModel.getInjuryInsurance());
                    model.setBelongToCoal(CoalConstant.LX_MINE);
                }
            }
            salaryExcelModels.add(model);

        }
        return salaryExcelModels;
    }
}
