package com.ruoyi.system.utils;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @author haiwe
 * @date 2024/6/24
 */
public class ValueUtils {

    public static Map<String, List<String>> extractOperands(String value) {
        Map<String, List<String>> operandsMap = new HashMap<>();
        List<String> operands = new ArrayList<>();
        List<String> operators = new ArrayList<>();

        StringBuilder operandBuilder = new StringBuilder();
        for (char c : value.toCharArray()) {
            if (isOperator(c)) {
                if (operandBuilder.length() > 0) {
                    operands.add(operandBuilder.toString().trim());
                    operandBuilder = new StringBuilder();
                }

                operators.add(String.valueOf(c));
            } else {
                operandBuilder.append(c);
            }
        }

        if (operandBuilder.length() > 0) {
            operands.add(operandBuilder.toString().trim());
        }

        operandsMap.put("operands", operands);
        operandsMap.put("operators", operators);

        return operandsMap;
    }

    //判断是否是操作符
    private static boolean isOperator(char c) {
        return c == '+' || c == '-' || c == '*' || c == '/';
    }

}
