package com.ruoyi.system.utils;

import com.ruoyi.system.mapper.WagesCompilationMapper;
import com.ruoyi.system.mapper.WagesVersionMapper;
import com.ruoyi.system.model.wages.dao.WagesCompilationExcelDAO;
import com.ruoyi.system.model.wages.dao.WagesVersionDAO;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.Optional;
import java.util.stream.Collectors;

/**
 * 2024/6/13
 */
@Component
public class WagesUtils {
    private WagesVersionMapper wagesVersionMapper;
    private WagesCompilationMapper wagesCompilationMapper;

    public WagesUtils(WagesVersionMapper wagesVersionMapper, WagesCompilationMapper wagesCompilationMapper) {
        this.wagesVersionMapper = wagesVersionMapper;
        this.wagesCompilationMapper = wagesCompilationMapper;
    }

    /**
     * 根据矿id和type获取对应的对照表id
     * @param mineId
     * @param type
     * @return
     */
    public Integer getComparisonId(String mineId, String type) {
        List<WagesCompilationExcelDAO> wagesCompilationExcelDAO = wagesCompilationMapper.selectByMineIdAndType(mineId, type);
        if (wagesCompilationExcelDAO == null || wagesCompilationExcelDAO.size() == 0) {
            return null;
        }
        List<Integer> collect = wagesCompilationExcelDAO.stream().map(v -> v.getVersionId()).collect(Collectors.toList());
        List<WagesVersionDAO> wagesVersionDAO = wagesVersionMapper.selectByVersionId();
        if (wagesVersionDAO == null || wagesVersionDAO.size() == 0) {
            return null;
        }
        Optional<WagesVersionDAO> first = wagesVersionDAO.stream().filter(v -> collect.contains(v.getVersionId()) && "1".equals(v.getOpenOrClose())).findFirst();
        if (first.isPresent()) {
            Integer id = first.get().getVersionId();
            return wagesCompilationExcelDAO.parallelStream().filter(v -> id.equals(v.getVersionId())).map(v -> v.getComparisonId()).findFirst().get();
        }
        return null;
    }
}
